//Joshua Stough
//July 20, 2001
//This is an attempt to implement my CS317 (Carleton CG) course final
//project on HIRES23-CS at UNC.  Yahoo!

#include <GL/glut.h>
#include <iostream.h> 
#include <fstream.h>
#include <math.h>
#include "z_wireback.h"


surface *SURF;
transformation *Current, *M, *E, *V, *Home, *Post_E, *Pre_E;
float r, g, b;
double eye_x, eye_y, eye_z, D, zoom_inc;
int wid, rotation_inc, which_menu, t_menu, move_type, tri_or_wire;

//clip w;

void Show_Menu(); 

void Set_E();
//For piecing together the Eye matrix.

//void Set_V();
//For composing the viewing matrix with the eye matrix.

void _gl(int choice, transformation *Q);
//For the gl command stuff;

void Rotation(char choice);
//For the jkl keystrokes.

void Pan_Zoom(char choice);
//For the bnm keystrokes.
	
void Inc_change();
//For changing the rotation and scaling constants.

void deg_to_rad(double &angle);
//Little utility function for converting deg to rad.

void TP(int i, int j);
//For making there be a tangent plane.

void Make_Current();

void Write_Surface();

void cbKey(unsigned char k, int x, int y)
{
//	glNewList(1, GL_COMPILE);
//              glCallList(2);
//                glCallList(3);
//        glEndList();

   if (which_menu == 1) { 
        switch (k) {
		
		case 'n':
			if (SURF != NULL) SURF->kill_surf();
			SURF = new surface();
			Show_Menu();
			break;
                case 'e':
                       	cout << "Enter x y z eye position: ";
	                cin >> eye_x >> eye_y >> eye_z;
			Show_Menu();
                        break;
		case 'd':
			Set_E();
			cout << "Set the E\n";
                        //Set_V();
			Home->Translation(1,1,1,0, 0, 0);
			Home->Compose(E);
			Current->Compose(Home);
			//cerr << "Set the V\n";
			//_gl(2, Home); 
			//cerr << "Ready to draw, but here's home first\n";
			//Home->show_matrix();
			//cerr << "There it was\n";
			which_menu = 2;
			Show_Menu();
			SURF->draw_surf(tri_or_wire);
			glPolygonMode(GL_FRONT, GL_LINE);
			glPolygonMode(GL_BACK, GL_LINE);
			glutPostRedisplay();
						break;
		case 'o':
			Inc_change();
			Show_Menu();
                        break;
                default: cerr << "invalid option\n";
			break;
  	}
   } else if (which_menu == 2) {
	switch (k) {
		case 'z':
			Pan_Zoom('z');
			break;
		case 'Z':
			Pan_Zoom('Z');
			break;
		case 'y':
			Pan_Zoom('y');
			break;
		case 'Y':
			Pan_Zoom('Y');
                        break;
		case 'x':
			Pan_Zoom('x');
                        break;
                case 'X':
			Pan_Zoom('X');
                        break;
		case 'j':
			Rotation('x');
			break;
		case 'J':
			Rotation('X');  
                        break;  
                case 'k':
                        Rotation('y');
                        break;          
                case 'K':
                        Rotation('Y');
                        break;
                case 'l':
                        Rotation('z');
                        break;
                case 'L':
                        Rotation('Z');
                        break;
		case 'm':
			if (move_type == 1) move_type = 2;
			else if (move_type == 2) move_type = 1;
			break;
		case 'P':
			t_menu = 1;
		//	SURF->print_surf(2);
			TP(0,0);
		//	cout << "Here's the surface after the creation of the tangent plane\n";
		//	SURF->print_surf(2);
			Show_Menu();
			break;
		case 's':
			TP(1,0);
			break;
		case 'S':
			TP(-1,0);
			break;
		case 't':
			TP(0, 1);
			break;
		case 'T':
			TP(0, -1);
			break;
		case 'C':
			tri_or_wire = -1*tri_or_wire;
			//SURF->draw_surf(tri_or_wire);
			if (tri_or_wire == -1) {
				glPolygonMode(GL_FRONT, GL_LINE);
				glPolygonMode(GL_BACK, GL_LINE);
			}else {
				cerr << "Yo\n";
				glPolygonMode(GL_FRONT, GL_FILL);
				glPolygonMode(GL_BACK, GL_FILL);
			}
			break;
		case 'W':
			Write_Surface();
			break;
		case 'h':
                        Post_E->Translation(1, 1, 1, 0, 0, 0);
			Pre_E->Translation(1, 1, 1, 0, 0, 0);
			Make_Current();
			//_gl(1, Current);
			break;
		case 'q':
			Post_E->Translation(1, 1, 1, 0, 0, 0);
                        Pre_E->Translation(1, 1, 1, 0, 0, 0);
			which_menu = 1;
			t_menu = 0;
                        Show_Menu();
                        break;
                default:
                        break;
	}
   }
   glutPostRedisplay();

}



void Inc_change()
{
   int resp;

   do {

   cout << "You can change the scaling and rotation increments.\n"
	<< "Press 1 for scaling, 2 for rotation, other to quit\n";

   cin >> resp;
   switch (resp) {
	case 1:
		cout << "The zoom/pan increment is currently\n"
		     << zoom_inc << "Enter a new (double) : "; 
		cin >> zoom_inc;
		break;
	case 2:
		cout << "The rotation increment and decrement are \n"
		     << rotation_inc << endl
		     << "Enter the desired rotation in integer deg\n";
		cin >> rotation_inc;
		break;
   }
   }while (resp == 1 || resp == 2);

}

void Set_E()
{


        double a = eye_x, b = eye_y, c = eye_z, sine, cosine;   
        E->Translation(1, 1, 1, -eye_x, -eye_y, -eye_z);
//cerr << "just made E a translation\n";
        M->xRotation(1, 0);
//cerr << "M is a rotation\n";

        E->Compose(M);
//cerr << "E is composed\n";	
        
        sine = double (b)/sqrt(a*a + b*b);
        cosine = double (a)/sqrt(a*a + b*b);
        M->yRotation(cosine, -sine);
//cerr << "M is a y rotation\n";
        E->Compose(M);
//cerr << "E is composed\n";
        
        sine = double (c)/sqrt(a*a + b*b + c*c);
        cosine = double (sqrt(a*a + b*b))/sqrt(a*a + b*b + c*c);
        M->xRotation(-sine, cosine);
//cerr << "M is an x rotation\n";
        E->Compose(M);
//cerr << "E is composed\n";


//We don't need to do this z fliping I think.
//        M->Translation(1, 1, -1, 0, 0, 0);
//cerr << "M is a scaling (flip the z)\n";
//        E->Compose(M);
//cerr << "Done creating E\n";
}

/*
void Set_V() 
{
        double x, y, u, v, span, scale;
cerr << "Doing the expensive eye_extremes\n";
        SURF->eye_extremes_util(E);
cerr << "done\n";
        
        SURF->extremes(x, y, u, v);

        if (u - x >= v - y) span = u - x;
        else span = v - y;
        
        scale = double (600)/span;

	V->Translation(double (scale)*D, double (scale)*D, 1, 0, 0, 0);
        V->perspective_utility(w);
cerr << "V is now a persp. matrix\n";
	Home->Translation(1,1,1,0, 0, 0);
	Home->Compose(E);
	Home->Compose(V);
}

*/

void Show_Menu()
{
   if (which_menu == 1) {
	cerr << "General Menu\n\n"
	     << "'n' Declare a new surface\n"
	     << "'e' Enter the eye position\n"
	     << "'d' Display Image\n"
	     << "'o' Change increments\n";
   }else if (which_menu == 2) {
	cerr << "Display Menu\n\n"
	     << "'x', 'y', 'z' to pan/zoom by " << zoom_inc << "\n"
	     << "'X', 'Y', 'Z' to pan/zoom by " << -zoom_inc << "\n"
	     << "'j', 'k', 'l' to rotate the eye by " << rotation_inc << "\n"
	     << "'J', 'K', 'L' to rotate the eye by " << -rotation_inc << endl
	     << "'m' to switch from airplane to rotate view\n"
	     << "'P' to see the tangent plane\n"
	     << "'h', to return the image to its original display\n"
	     << "'q', to return to the General Menu \n";
   }
   if (t_menu == 1) {
	cerr << "'s', 'S' to move the tangent plane along the s variable\n"
	     << "'t', 'T' to move the tangent plane along the t variable\n";
   }
}
/*
void _gl(int choice, transformation *Q)
{

  if (choice == 1) {
	glDeleteLists(2,2);
	glNewList(2, GL_COMPILE);
        glClearColor(0.0,0.0,0.0,0.0);
        glClear(GL_COLOR_BUFFER_BIT);
        glColor3f (r, g, b);
        SURF->draw_surf(Q, w);
	glFlush();
	glEndList();

	glNewList(3, GL_COMPILE);
	SURF->draw_t_plane(Q, w);
	glFlush();
	glEndList();


	glCallList(2);
	glCallList(3);
	glFlush();
  }
  else if (choice == 3) {
        glDeleteLists(3,1);
        glNewList(3, GL_COMPILE);
        SURF->draw_t_plane(Q, w);
        glFlush();
        glEndList();

		glCallList(3);
		glFlush();
  }
  else if (choice == 2) {
        glDeleteLists(2,2);
        glNewList(2, GL_COMPILE);
        glClearColor(0.0,0.0,0.0,0.0);
        glClear(GL_COLOR_BUFFER_BIT);
        glColor3f (r, g, b);
	SURF->draw_surf(Q, w);
	glFlush();
        glEndList();

		glCallList(2);
		glFlush();
  }
}
*/

void Pan_Zoom(char choice)
//For pan/zoom, like movements of the eye.
{
   switch (choice) {
      	case 'x': M->Translation(1, 1, 1, zoom_inc, 0, 0);
		  break;
	case 'X': M->Translation(1, 1, 1, -zoom_inc, 0, 0);
		  break;
	case 'y': M->Translation(1, 1, 1, 0, zoom_inc, 0);
		  break;
	case 'Y': M->Translation(1, 1, 1, 0, -zoom_inc, 0);
		  break;
	case 'z': M->Translation(1, 1, 1, 0, 0, zoom_inc);
		  break;
	case 'Z': M->Translation(1, 1, 1, 0, 0, -zoom_inc);
		  break;
	default: cerr << "Translation menu: invalid choice: " << choice << endl;
   		 exit(0);
   }
 
   Post_E->Compose(M);

   Make_Current();

 //  _gl(1, Current);

   glutPostRedisplay();

}	

void deg_to_rad(double &angle)
{
   double temp = angle, pi = 3.141596;
  
   angle = (double) pi*temp/180.0;
}

void Rotation(char choice)
//For rotating the eye, though it may no longer point to the origin.
{
   double cosine, sine, angle = rotation_inc;
  
   deg_to_rad(angle);
   cosine = cos(angle);
   sine = sin(angle);

   switch (choice) {
        case 'x': M->xRotation(sine, cosine);
		  break;
	case 'X': M->xRotation(-sine, cosine);
		  break;
	case 'y': M->yRotation(sine, cosine);
		  break;
	case 'Y': M->yRotation(-sine, cosine);
		  break;
	case 'z': M->zRotation(sine, cosine);
		  break;
	case 'Z': M->zRotation(-sine, cosine);
		  break;
	default: cerr << "Rotation menu: invalid choice: " << choice << endl;
		 exit(0);
   }
   if (move_type == 1) Post_E->Compose(M);
   else if (move_type == 2) Pre_E->iCompose(M); 
  	
   Make_Current(); 

//   _gl(1, Current); 

   glutPostRedisplay();
}
 
void TP(int i, int j)
{
   double s, t;

   SURF->_TP(i,j);
   SURF->draw_t_plane(tri_or_wire);
 //  _gl(3, Current);

   SURF->give_st(s, t);
   cerr << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b"
	    << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b";
   cerr << "s= " << s << ", t= " << t << "....";
   glutPostRedisplay();
}

void Make_Current()
{
	Current->Translation(1, 1, 1, 0, 0, 0);
        Current->Compose(Pre_E);
        Current->Compose(E);
        Current->Compose(Post_E);
//        Current->Compose(V);
}

	 
void RenderDisplay()
{
	GLdouble mat[16];
	GLdouble mat2[16];

	//lighting stuff down
		GLfloat light_dr = 0.6f;
        GLfloat light_dg = 0.6f;
        GLfloat light_db = 0.6f;
        GLfloat light_ar = 0.3f;
        GLfloat light_ag = 0.3f;
        GLfloat light_ab = 0.3f;
        GLfloat sqrt3 = 0.5774f;

        GLfloat light0_diffuse[4] = {light_dr, light_dg, light_db, 1.0f};
        GLfloat light0_ambient[4] = {light_ar, light_ag, light_ab, 1.0f};
        GLfloat light0_specular[4] = {1.0f, 1.0f, 1.0f, 1.0f};
        GLfloat light0_position[4] = {0.0f, 100.0f, 100.0f, 0.0f};

		GLfloat brass_ambient[] =
		{0.8f, 0.5f, 1.00f, 1.0f}, brass_diffuse[] =
		{0.5f, 0.5f, 0.7f, 1.0f}, brass_specular[] =
		{1.0f, 1.0f, 1.0f, 1.0f}, brass_shininess = 50.8f;


        GLfloat model_ambient[4] = {0.0f, 0.0f, 0.0f, 1.0f};

        GLfloat mat_specular[4] = { 1.0f, 0.0f, 0.0f, 1.0f };
        GLfloat mat_diffuse[4] = { 1.0f, 0.0f, 0.0f, 1.0f };
        GLfloat mat_shininess[] = {50.0f};
        GLfloat mat_emission[4] = {0.0f, 0.0f, 0.0f, 1.0f};

		glEnable(GL_LIGHTING);
        glEnable(GL_NORMALIZE);
        glEnable(GL_LIGHT0);
        glLightfv( GL_LIGHT0, GL_AMBIENT, light0_ambient);
        glLightfv( GL_LIGHT0, GL_DIFFUSE, light0_diffuse);
        glLightfv( GL_LIGHT0, GL_SPECULAR, light0_specular);
        glLightfv( GL_LIGHT0, GL_POSITION, light0_position);
        glLightModelfv( GL_LIGHT_MODEL_AMBIENT, model_ambient);

		glMaterialfv(GL_FRONT, GL_SPECULAR, brass_specular);
        glMaterialf(GL_FRONT, GL_SHININESS, brass_shininess);
        glMaterialfv(GL_FRONT, GL_DIFFUSE, brass_diffuse);

		
		//The below enclosed are my own lighting stuff.
		GLfloat light1_position[4] = {-100.0f, -100.0f, -100.0f, 0.0f}; 
		glEnable(GL_LIGHT1);
        glLightfv( GL_LIGHT1, GL_AMBIENT, light0_ambient);
        glLightfv( GL_LIGHT1, GL_DIFFUSE, light0_diffuse);
        glLightfv( GL_LIGHT1, GL_SPECULAR, light0_specular);
        glLightfv( GL_LIGHT1, GL_POSITION, light1_position);

		GLfloat light2_position[4] = {150.0f, -150.0f,0.0f,0.0f};
		glEnable(GL_LIGHT2);
        glLightfv( GL_LIGHT2, GL_AMBIENT, light0_ambient);
        glLightfv( GL_LIGHT2, GL_DIFFUSE, light0_diffuse);
        glLightfv( GL_LIGHT2, GL_SPECULAR, light0_specular);
        glLightfv( GL_LIGHT2, GL_POSITION, light2_position);

//		GLfloat light3_position[4] = {-150.0f, 0.0f,0.0f,0.0f};
//		glEnable(GL_LIGHT3);
  //    glLightfv( GL_LIGHT3, GL_AMBIENT, light0_ambient);
    //  glLightfv( GL_LIGHT3, GL_DIFFUSE, light0_diffuse);
      //glLightfv( GL_LIGHT3, GL_SPECULAR, light0_specular);
      //glLightfv( GL_LIGHT3, GL_POSITION, light3_position);

		GLfloat light4_position[4] = {-150.0f, 150.0f,0.0f,0.0f};
		glEnable(GL_LIGHT4);
        glLightfv( GL_LIGHT4, GL_AMBIENT, light0_ambient);
        glLightfv( GL_LIGHT4, GL_DIFFUSE, light0_diffuse);
        glLightfv( GL_LIGHT4, GL_SPECULAR, light0_specular);
        glLightfv( GL_LIGHT4, GL_POSITION, light4_position);

//		GLfloat light5_position[4] = {0.0f, -150.0f,0.0f,0.0f};
//		glEnable(GL_LIGHT5);
//      glLightfv( GL_LIGHT5, GL_AMBIENT, light0_ambient);
//      glLightfv( GL_LIGHT5, GL_DIFFUSE, light0_diffuse);
//      glLightfv( GL_LIGHT5, GL_SPECULAR, light0_specular);
//      glLightfv( GL_LIGHT5, GL_POSITION, light5_position);
        

//lighting stuff up

		glEnable(GL_DEPTH_TEST);
	

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0, 1.0, 0.01, 400.0);

	
	glMatrixMode(GL_MODELVIEW);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	glPushMatrix();
	glTranslated(0.0, 100.0, 100.0);
	glColor4f(0.7,0.2,0.0,0.65);
	glutWireSphere(5, 20, 20);

	glPopMatrix();
	glPushMatrix();
	glTranslated(-100.0, -100.0, -100.0);
	glColor4f(0.7,0.2,0.0,0.65);
	glutWireSphere(5, 20, 20);

	glPopMatrix();
	glPushMatrix();
	glTranslated(-150.0, 150.0, 0.0);
	glColor4f(0.7,0.2,0.0,0.65);
	glutWireSphere(5, 20, 20);

	glPopMatrix();
	glPushMatrix();
	glTranslated(150.0, -150.0, 0.0);
	glColor4f(0.7,0.2,0.0,0.65);
	glutWireSphere(5, 20, 20);

	glPopMatrix();


	//glLoadIdentity();
	Current->Get_Mat(mat);
	glLoadMatrixd(mat);

	glGetDoublev(GL_MODELVIEW_MATRIX, mat2);

	//for (int i = 0; i < 16; i++) cerr << mat2[i] << " ";
	//cerr << endl;

	if (which_menu == 2)
		//SURF->draw_surf(tri_or_wire);
		//glCallList(1);
		glDrawArrays(GL_TRIANGLE_STRIP, 0, SURF->draw_Arrays_count());
	glDisable(GL_LIGHTING);
	if (t_menu == 1)
		//SURF->draw_t_plane(tri_or_wire);
		glCallList(2);

	glBegin(GL_LINES);
    	glColor3f(1.0, 0.0,0.0);
		glVertex3d(0.0,0.0,0.0);
		glVertex3d(50.0,0.0,0.0);
		glColor3f(0.0,1.0,0.0);
		glVertex3d(0.0,0.0,0.0);
		glVertex3d(0.0,50.0,0.0);
		glColor3f(0.5, 0.9, 1.0);
		glVertex3d(0.0,0.0,0.0);
		glVertex3d(0.0,0.0,50.0);
	glEnd();

}

void cbDisplay()
{
        glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
        glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
        
//		glMatrixMode(GL_PROJECTION);
//		glLoadIdentity();
//		Current->Get_Mat(mat);
//		glMultMatrixd(mat);
//		glMatrixMode(GL_MODELVIEW);
//		glLoadIdentity();
        RenderDisplay();
        glutSwapBuffers();

}

void Write_Surface()
{
	char *filename = new char();

	cerr << "Please provide a filename:\n";
	cin >> filename;

	SURF->write_surf(filename);
}
	
void main(int argc,char *argv[])
{
        SURF = NULL;

        Current = new transformation();
        M = new transformation();
        Home = new transformation();
        Post_E = new transformation();
	E = new transformation();
	V = new transformation();
	Pre_E = new transformation();
	Pre_E->Translation(1, 1, 1, 0, 0, 0);
	Post_E->Translation(1, 1, 1, 0, 0, 0);
	Current->Translation(1, 1, 1, 0, 0, 0);

 r = 0.0; g = 0.0; b= 1.0;
 eye_x = 30; eye_y = 30; eye_z = 30; D = 15;  zoom_inc = 3;
 rotation_inc = 5; which_menu = 1; t_menu = 0; move_type = 1;
 tri_or_wire = -1;

//       w.xleft = -300; w.xright = 300; w.ybottom = -300; w.ytop = 300;
//	w.box_xl = -290; w.box_xr = 290; w.box_yb = -290; w.box_yt = 290;
//        w.box_zh = 15; w.box_zy = 200;

        glutInit(&argc, argv);

        glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB);
        glutInitWindowPosition(100, 100);
        wid = glutCreateWindow("Graphic.");
		glutSetWindow(wid);

		glutKeyboardFunc(cbKey);	
        glutDisplayFunc(cbDisplay);
		Show_Menu();
        glutMainLoop();

}